<template>
	<mind-layout>
		<template slot="toolbar-actions">
			<el-button type="primary" 
				v-if="actionAdd"
				icon="el-icon-circle-plus" 
				size="small" 
				@click="onNew"
				> Crear
			</el-button>
			<!--<el-button 
				v-if="actionEdit"
				type="primary" 
				plain 
				icon="el-icon-edit-outline" 
				size="small" 
				:disabled="!selectedRow" 
				@click="onEdit(selectedRow)"
				>Editar
			</el-button>
			<el-button 
				v-if="actionDelete"
				type="danger" 
				plain 
				icon="el-icon-delete" 
				size="small"  
				:disabled="!selectedRow" 
				@click="onDelete(selectedRow)"
				>Eliminar
			</el-button>-->
			<!-- <el-button type="primary"  icon="el-icon-search" size="small" plain  @click="$emit('update:filterActivator', !filterActivator)">Buscar</el-button> -->
			<slot name="actions" :selectedRow="selectedRow"/>
		</template>
		<div class="flex-column">
			<div v-show="$scopedSlots.filter">
				<el-collapse >
					<el-collapse-item title="Filtros">
						<el-form ref="form"  label-width="120px" size="mini">
							<el-main>
								<slot  name="filter" :form="filtros"/>
							</el-main>
							<el-footer>
								<el-row type="flex"  justify="end">
									<el-col >
										<el-button type="primary" plain size="mini" @click="clear">Limpiar</el-button>
										<el-button type="primary" size="mini" @click="$emit('filter', filtros)">Filtrar</el-button>
									</el-col>
								</el-row>
							</el-footer>
						</el-form>
					</el-collapse-item>
				</el-collapse>
			</div>
			<div style="flex-grow:1;flex-shrink:1;overflow:hidden;">
				<mind-table :data="data" :row-key="rowKey" @select-one="onSelect" :row-class-name="rowClassName" class="table-height">
					<slot />
					<el-table-column v-if="actionDelete || actionEdit || actionCustom"  width="120" label=""  >
						<template v-slot="{row}">
							<div class="row-actions" v-if="row == selectedRow">
								<slot name="row-actions" :row="row" />
								<el-button v-if="actionDelete" class="boton-tabla" type="danger"  icon="el-icon-delete" @click="onDelete(row)"></el-button>
								<el-button v-if="actionEdit" class="boton-tabla" type="primary"  icon="el-icon-edit" @click="onEdit(row)"></el-button>
							</div>
						</template>
					</el-table-column>
				</mind-table>
			</div>
		</div>
	</mind-layout>
</template>

<script>

export default {
	props: {
		/**
		 * datos a utilizar para completar la tabla
		 */
		data: Array,
		/**
		 * clave primaria del registro, es utilizada para realizar los ruteos
		 */
		rowKey: String,

		/**
		 * path base. es utilizado para la redirección de las acciones edit y new
		 */
		path:String,

		rowClassName: Function,

		/**
		 * Indica si se debe activar el filtro
		 */
		filterActivator: Boolean,

		/** 
		 * Indica si se debe mostrar el botón de agregar recurso
		*/
		actionAdd: {
			type: Boolean,
			default: true
		},
		/** 
		 * Indica si se debe mostrar el botón de eliminar recurso
		*/
		actionDelete: {
			type: Boolean,
			default: true
		},
		/** 
		 * Indica si se debe mostrar el botón de editar recurso
		*/
		actionEdit: {
			type: Boolean,
			default: true
		},
		/** 
		 * Indica si se deben mostrar los botones enviados en el slot `row-actions`
		*/
		actionCustom: {
			type: Boolean,
			default: false
		},


	},

	methods: {
		/**
		 * Elimina el recuros especificado
		 * @param recurso recurso del elemento a eliminar
		 */
		async onDelete(recurso){
			this.$confirm(`¿Eliminar el recurso ${recurso.id}?`, 'Warning', {
				confirmButtonText: 'OK',
				cancelButtonText: 'Cancelar',
				type: 'warning'
			}).then(async () => {
				this.selectedRow = null
				this.$emit('delete', recurso[this.rowKey])
			}).catch(() => {
				this.$message({
					type: 'info',
					message: 'Eliminación Cancelada'
				});
			});


		},
		onEdit(resource) {
			if(!this.rowKey) {
				throw('Error, no se definió la clave primara para el recurso')
			}

			const key = this.rowKey
			const path = `${this.path}/${resource[key]}`
			this.$router.push(path)

			// this.$emit('edit', resource)
		},

		onNew() {
			if(!this.path) {
				throw('Error, no se definió el path para la vista')
			}
			const path = `${this.path}/new`
			this.$router.push(path)
		},
		onSelect(row) {
			this.selectedRow = row
		},
		clear() {
			this.filtros = {}
			this.$emit('filter-reset')
			this.$emit('filter', this.filtros)

		}

	},
	data() {
		return {
			selectedRow: null,
			filtros: {},
		}
	}
	
}
</script>
<style scoped>
.flex-column {
	height: calc(100%);
	overflow: auto;
	display: flex;
	flex-direction: column;
}

.row-actions {
	float:right;
}

.boton-tabla {
	margin: 0;
	padding: 4px !important;
	margin: 2px !important;
}
</style>
